import QtQuick 2.0

import ru.astralinux.plasma.private.restartplasmashell 1.0

Item {
    id: root

    RestartPlasmaShell {
        id: restartPlasmaShell
    }

    function watch(client) {
        client.unresponsiveChanged.connect((unresponsive) => {
            if (unresponsive) {
               restartTimer.restart();
            } else {
               restartTimer.stop();
            }
        });
    }

    Timer {
        interval: 100
        running: true

        onTriggered: {
            if (restartPlasmaShell.isKWinRestarted()) {
                console.log("KWin crashed, restart plasmashell!");
                restartPlasmaShell.restartShell();
            } else {
                restartPlasmaShell.setMinScoreAdj();
            }
        }
    }

    Timer {
        id: restartTimer

        interval: restartPlasmaShell.frozenTimeout
        running: false

        onTriggered: {
            console.log("Plasma Mobile frozened, restart plasmashell!");
            restartPlasmaShell.restartShell();
        }
    }

    Connections {
        target: workspace

        function onClientAdded(client) {
            if (client.caption.indexOf("Plasma Mobile") >= 0)
                root.watch(client);
        }
    }
}
